/* Programme de capture de Logs de serveur hlds counter strike
   6 Avril 2005: Premire bauche termine

   sous GPL
   Franois Boisson
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <time.h>
#include <pwd.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <signal.h>
#include <pthread.h>
#include <malloc.h>

#include "rcon.h"
#include "rconmysql.h"
#define DEBUG 0

#define PORT 27015
/*
#define PORTLOCAL 27000
*/
#define TAILLE_PAQUET 1400
#define NBRE_PAQUETS 16
#define TMAX 100000
#define NBENTREE 2000

char *desc_serveur=".rconhlds";
int douille;
char buffer_total[TAILLE_PAQUET*NBRE_PAQUETS];
char *buffer;
char *IPlocale,*prtlc;
char *stop="0.0.0.0";
char *pass = NULL;
char debut[]="challenge rcon";
char cmdlog[]="logaddress";
char challenge[32];
double temps,tempst; 
struct sockaddr_in adresse;
struct sockaddr_in adresser;
int fichier_sortie=-1;
char ligne_sortie[512];

pthread_mutex_t mutex_file = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutex_boulot = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond_boulot = PTHREAD_COND_INITIALIZER;
pthread_mutex_t mutex_fini = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond_fini = PTHREAD_COND_INITIALIZER;
pthread_t tache;

int STOP=0;


#define TAILLE_FILE 1024

char **lignes;
int ligne_encours;
int derniere_ligne;

void rajoute()
{
  pthread_mutex_lock(& mutex_file);
  derniere_ligne = (derniere_ligne+1) % TAILLE_FILE;
  lignes[derniere_ligne] = malloc(TAILLE_PAQUET);
  pthread_mutex_unlock(& mutex_file);
  buffer = lignes[derniere_ligne];
  pthread_mutex_lock(& mutex_boulot);
  pthread_cond_signal(& cond_boulot);
  pthread_mutex_unlock(& mutex_boulot);
}


void * tache_de_fond(queud)
     void *queud;
{
  while(STOP==0)
    {
      while (ligne_encours != derniere_ligne)
	{
	  traite(lignes[ligne_encours]+8);
	  free(lignes[ligne_encours]);
	  ligne_encours = (ligne_encours +1) %TAILLE_FILE;
	}
      pthread_mutex_lock(& mutex_boulot);
      pthread_cond_wait(& cond_boulot,& mutex_boulot);
      pthread_mutex_unlock(& mutex_boulot);
    }
  if (DEBUG==1) printf("Stop Thread\n");
  pthread_mutex_lock(& mutex_fini);
  pthread_cond_signal(& cond_fini);
  pthread_mutex_unlock(& mutex_fini);
  if (DEBUG==1) printf("Retour Thread\n");
  pthread_exit(NULL);
}


int useSQL = 0;
int Na1=0;
int Na2=0;
int Na3=0;
int Na4=0;
int Na5=0;
int Na6=0;
int Na7=0;
int Na8=0;

/* Fonctions utiles au parsage de la ligne */

char *CTS="(CT)";
char *TS="(T)";

#define equipe(x) (x ? TS : CTS)


int recherche(motif,chaine)
char *motif,*chaine;
{
  int i,j,r;
  r = 0;
  for (i=0;(chaine[i]!=0)&& (r==0);i++)
    {
      j=0;
      while ((motif[j]!=0) && (motif[j] == chaine[i+j])) j++;
      if (motif[j]==0) r=1;
    }
  if (r==1) return(--i); else return(-1);
}

int retrorecherche(motif,chaine,pos)
char *motif,*chaine;
int pos;
{
  int i,j,r;
  r = 0;
  for (i=pos;(i>=0)&& (r==0);i--)
    {
      j=0;
      while ((motif[j]!=0) && (motif[j] == chaine[i+j])) j++;
      if (motif[j]==0) r=1;
    }
  if (r==1) return(++i); else return(-1);
}

/* decode un numro dans p et rend le nombre de caractres utiliss */ 
int numero(ligne,p)
     char *ligne;
     int *p;
{
  int i;
  *p=0;
  i=0;
  while ((ligne[i] >= '0') && (ligne[i] <= '9'))
    *p=10*(*p)+(ligne[i++]-'0');
  return(i);
}

char *cherchechaine(motif,ligne,taille)
     char *motif,*ligne;
     int taille;
{
  /* dans ligne, on recherche la premire occurrence de motif, puis, on renvoit la chaine de caractre
     qu'il y a aprs entre " */
  int i,j,k;
  char *res;
  if ((i=recherche(motif,ligne)) <0) return(NULL);
  if ((j=recherche("\"",ligne+i)) <0) return(NULL);
  j +=i+1; /* ligne[j] -> premier char aprs " */
  if ((i=recherche("\"",ligne+j)) <0) return(NULL);
  res = malloc(taille);
  for (k=0;((k<i) &&(k<taille-1));k++) res[k]=ligne[j+k];
  res[k]=0;
  return(res);
}

int chercheentier(motif,ligne)
     char *ligne,*motif;
{
  /* recherche dans ligne l'entier aprs motif: motif "34" renvoit 34 */
  int i,j,k;
  char *res;
  if ((i=recherche(motif,ligne)) <0) return(-1);
  if ((j=recherche("\"",ligne+i)) <0) return(-1);
  j +=i+1; /* ligne[j] -> premier char aprs " */
  if (numero(ligne+j,&k) == 0) return(-1);
  return(k);
}

/* Parsage de la ligne */ 


#define RETOUR   {free(nom1);free(steam_id1);free(nom2);free(steam_id2);free(arg1);free(arg2);free(arg3);free(arg4);free(arg5);free(arg6);free(arg7);free(arg8);return(0);}

int traite(ligne)
char *ligne;
{

  char *steam_id1=NULL;
  char *nom1=NULL;
  int num1=0;
  int eq1; /* 0=CT,1=T */

  char *steam_id2=NULL;
  char *nom2=NULL;
  int num2=0;
  int eq2;

  char *arg1=NULL;
  char *arg2=NULL;
  char *arg3=NULL;
  char *arg4=NULL;
  char *arg5=NULL;
  char *arg6=NULL;
  char *arg7=NULL;
  char *arg8=NULL;
  int narg1=-1;
  int narg2=-1;
  int narg3=-1;
  int narg4=-1;
  int narg5=-1;
  int narg6=-1;
  int narg7=-1;
  int narg8=-1;

  float rarg1;
  float rarg2;
  float rarg3;
  float rarg4;
  float rarg5;
  float rarg6;


  int action;

  int j,i1,ij1,ijf1,ij2,ijf2,im,imf,i3,i2;
  /* recherche de STEAM */
  action = 0;
  if (recherche("STEAM_ID_PENDING",ligne) >= 0) return(0);

  /* Y-a-t-il un joueur voqu */

  if (recherche("STEAM_") >= 0) 
    {
      /* caractristique joueur 1 */

      if ((ij1= recherche(": \"",ligne)) <0) return(0);
      ij1+=3; /* ij1 est le dbut du nom 1 */
      if ((i1 = recherche("<STEAM_",ligne)) < 0) return(0);
      if ((ijf1= retrorecherche("<",ligne,i1-1)) <0) return(0);
      nom1=malloc(32);
      for (j=0;((ij1+j<ijf1)&&(j<31));j++) nom1[j]=ligne[ij1+j];
      nom1[j]=0;
      numero(ligne+ijf1+1,&num1);

      if ((ij1=recherche(">",ligne+i1)) <0) return(0);
      steam_id1=malloc(20);
      for(j=0;(1+j<ij1)&&(j<19);j++) steam_id1[j]=ligne[i1+1+j];
      steam_id1[j]=0;
      if (ligne[i1+ij1+2] == 'C') eq1=CT;
      else eq1 = TERRO;

      /* caractristique joueur 2*/

      if ((i2 = recherche("<STEAM_",ligne+i1+1)) >= 0)
	{
	  i2 += i1+1;
	  if ((ijf2= retrorecherche("<",ligne,i2-1)) <0) RETOUR;
	  if ((ij2= retrorecherche(" \"",ligne,i2-1)) <0) RETOUR;
	  ij2=ij2+2;
	  nom2=malloc(32);
	  for (j=0;((ij2+j<ijf2)&&(j<31));j++) nom2[j]=ligne[ij2+j];
	  nom2[j]=0;
	  numero(ligne+ijf2+1,&num2);
	  if ((ij2=recherche(">",ligne+i2)) <0) RETOUR;
	  steam_id2=malloc(20);
	  for(j=0;(1+j<ij2)&&(j<19);j++) steam_id2[j]=ligne[i2+1+j];
	  steam_id2[j]=0;
	  if (ligne[i2+ij2+2] == 'C') eq2=CT;
	  else eq2 = TERRO;
	}
      

    }
  if (recherche(">\" killed \"",ligne) >= 0) 
    {
      action = RC_KILL;
      arg1 = cherchechaine(" with \"",ligne,10);
      /*
      printf("J1:%s %d %s %d -- %s --",nom1,num1,steam_id1,eq1,arg1);
      printf("J2:%s %d %s %d\n",nom2,num2,steam_id2,eq2);
      */
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"%s%s tue %s%s avec %s\n",nom1,equipe(eq1),nom2,equipe(eq2),arg1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche(" triggered \"Terrorists_Win\"",ligne) >= 0)
    {
      action = RC_TERROWIN;
      narg1 = chercheentier(" (CT \"",ligne);
      narg2 = chercheentier(") (T \"",ligne);
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*CT: %d, T: %d\n",narg1,narg2));
      /* fsync(fichier_sortie); */
    }
  else if (recherche(" triggered \"CTs_Win\"",ligne) >= 0)
    {
      action = RC_CTWIN;
      narg1 = chercheentier(" (CT \"",ligne);
      narg2 = chercheentier(") (T \"",ligne);
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*CT: %d, T: %d\n",narg1,narg2));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("World triggered \"Game_Commencing\"",ligne) >= 0)
    {
      action = RC_GAMEBEGIN;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*Le jeu commence\n"));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("World triggered \"Round_Start\"",ligne) >= 0)
    {
      action = RC_ROUNDSTART;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*Debut du round\n"));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("World triggered \"Round_End\"",ligne) >= 0)
    {
      action = RC_ROUNDEND;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*Fin du round\n"));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("Started map \"",ligne) >= 0)
    {
      action = RC_CHANGEMAP;
      arg1 = cherchechaine("Started map ",ligne,16);
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*** passage  la carte %s\n",arg1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("\" a banni et kicke \"",ligne) >= 0)
    {
      action = RC_BAN;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,">>> %s a banni %s\n",nom1,nom2));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("\" a kicke \"",ligne) >= 0)
    {
      action = RC_KICK;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,">>> %s a kick %s\n",nom1,nom2));
      /* fsync(fichier_sortie); */
    }
  else if (recherche(" joined team \"TERRORIST\"",ligne) >= 0)
    {
      action = RC_JOINTERRO;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*** %s rejoint les TERROS\n",nom1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche(" joined team \"CT\" ",ligne) >= 0)
    {
      action = RC_JOINCT;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*** %s rejoint les CTS\n",nom1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("\" triggered \"Planted_The_Bomb\"",ligne) >= 0)
    {
      action = RC_PLANT;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"%s plante la bombe\n",nom1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("\" triggered \"Defused_The_Bomb\"",ligne) >= 0)
    {
      action = RC_DEFUSE;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"%s dsamorce la bombe\n",nom1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche("\" say \"",ligne) >= 0)
    {
      action = RC_SAY;
      arg1 = cherchechaine(" say \"",ligne,256);
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"--- %s: %s\n",nom1,arg1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche(" entered the game",ligne) >= 0)
    {
      action = RC_ENTRE;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*** %s entre en jeu\n",nom1));
      /* fsync(fichier_sortie); */
    }
  else if (recherche(" changed name to \"",ligne) >= 0)
    {
      action = RC_NAME;
      arg1=cherchechaine(" changed name to ",ligne,36);
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*** %s change son nom en %s\n",nom1,arg1));
      /* fsync(fichier_sortie); */
    }
  else if ((recherche(" disconnected",ligne) >= 0) && (steam_id1 != NULL) && (nom1 != NULL))
    {
      action = RC_SORT;
      rarg1 = (Na2*100.0)/Na1;
      rarg2 = (Na4*100.0)/Na3;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"%s (%s) score: %d/%d (TK: %d) avec %'.1f (sur 100) de HS et %'.1f (sur 100) succs dans les tirs\n",nom1,steam_id1,Na3,Na7,Na5,rarg2,rarg1));
      /* fsync(fichier_sortie); */
      Na1 =0;
      Na2=0;
      Na3=0;
      Na4=0;
      Na5=0;
      Na6=0;
      Na7=0;
      write(fichier_sortie,
	    ligne_sortie,
	    snprintf(ligne_sortie,512,"*** %s sort du jeu\n",nom1));
      /* fsync(fichier_sortie); */
    }
  else if ((i1=recherche(" triggered \"weaponstats\" ",ligne)) >= 0)
    {
      action = RC_STAT;
      /* arme */
      arg1 = cherchechaine("(arme",ligne+i1,10);
      /* tirs */
      narg1 = chercheentier("(tirs",ligne+i1);
      narg2 = chercheentier("(impacts",ligne+i1);
      narg3 = chercheentier("(tues",ligne+i1);
      narg4 = chercheentier("(headshots",ligne+i1);
      narg5 = chercheentier("(tks",ligne+i1);
      narg6 = chercheentier("(dommages",ligne+i1);
      narg7 = chercheentier("(morts",ligne+i1);
      if (useSQL == 1) 
	{
	  if (DEBUG==1) printf("Appel de update_pseudo\n");
	  if (update_pseudo(steam_id1,nom1) < 0) printf("SQLerr: UP\n");
	  if (update_scores(steam_id1,nom1,arg1,narg1,narg2,narg3,narg4,narg5,narg6,narg7) < 0) printf("SQLerr: US\n");
	}
      Na1+=narg1;
      Na2+=narg2;
      Na3+=narg3;
      Na4+=narg4;
      Na5+=narg5;
      Na6+=narg6;
      Na7+=narg7;
    }

  else if ((i1=recherche(" triggered \"weaponstats2\" ",ligne)) >= 0)
    {
      action = RC_STAT;
      /* arme */
      arg1 = cherchechaine("(arme",ligne+i1,10);
      /* tirs */
      narg1 = chercheentier("(tete ",ligne+i1);
      narg2 = chercheentier("(poitrine ",ligne+i1);
      narg3 = chercheentier("(ventre ",ligne+i1);
      narg4 = chercheentier("(bras gauche ",ligne+i1);
      narg5 = chercheentier("(bras droit ",ligne+i1);
      narg6 = chercheentier("(jambe ",ligne+i1);
      i1 = recherche(" (jambe ",ligne)+5;
      narg7 = chercheentier("(jambe ",ligne+i1);
      if (useSQL == 1) 
	{
	  if (DEBUG==1) printf("Appel de update_arme\n");
	  if (update_armes(steam_id1,nom1,arg1,narg1,narg2,narg3,narg4,narg5,narg6,narg7) < 0) printf("SQLerr: UA\n");
	}
    }
  RETOUR;
    
  
}

/* Bof */

void erreur(message)
char *message;
{
  printf("Erreur %s\n",message);
  perror("Message d'erreur: ");
  exit(1);
}


char *intostring(ent,n)
int ent,n;
{
  char *resultat;
  resultat = malloc(n+1);
  resultat[n] = 0;
  do {
    resultat[--n] = (ent % 10) + '0';
    ent = ent/10;
  } while (ent >0);
  return(&(resultat[n]));
}

void arret(inutile)
     int inutile;
{
  int i,j,k,l;
  char buffer_arret[TAILLE_PAQUET];
  /* fermeture de la base */
  if (pthread_equal(tache,pthread_self()))
    {
      if (DEBUG==1) printf("Hmm, CtrlC sur le Thread\n");
      return(0);
    }

  if (DEBUG==1) printf("Arret de logrecept\n");
  /* envoi rcon */
  buffer_arret[0]=buffer_arret[1]=255;
  buffer_arret[2]=buffer_arret[3]=255;
  k=4;
  for (j=0;debut[j]!=0;j++) buffer_arret[k++]=debut[j];
  buffer_arret[k]=0;
  sendto(douille,buffer_arret,k,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));

  l=recvfrom(douille,buffer_arret,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,
	    &i);

  for (k=19;(k<l) && (buffer_arret[k] !=10);k++) challenge[k-19]=buffer_arret[k];

  challenge[k-19]=0;
  printf("Challenge: %s\n",challenge);

  /* preparation commande logaddress stop portlocal */
  buffer_arret[0]=buffer_arret[1]=255;
  buffer_arret[2]=buffer_arret[3]=255;
  k=4;
  buffer_arret[k++]='r';
  buffer_arret[k++]='c';
  buffer_arret[k++]='o';
  buffer_arret[k++]='n';
  buffer_arret[k++]=' ';
  for (j=0;challenge[j]!=0;j++) buffer_arret[k++]=challenge[j];
  buffer_arret[k++]=' ';
  buffer_arret[k++]='"';
  for (j=0;pass[j]!=0;j++) buffer_arret[k++]=pass[j];
  buffer_arret[k++]='"';
  buffer_arret[k++]=' ';
  for (j=0;cmdlog[j]!=0;j++) buffer_arret[k++]=cmdlog[j];
  buffer_arret[k++]=' ';
  for (j=0;stop[j]!=0;j++) buffer_arret[k++]=stop[j];
  buffer_arret[k++]=' ';
  for (j=0;prtlc[j]!=0;j++) buffer_arret[k++]=prtlc[j];
  sendto(douille,buffer_arret,k,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));
  

  close(douille);
  temps=(times(NULL)-temps)*10000/CLOCKS_PER_SEC;


  pthread_mutex_lock(& mutex_fini);
  STOP=1;
  /* attente de la fin du thread */
  pthread_mutex_lock(& mutex_boulot);
  pthread_cond_signal(& cond_boulot);
  pthread_mutex_unlock(& mutex_boulot);
  if (DEBUG==1) printf("Attente du thread\n");
  pthread_cond_wait(& cond_fini,& mutex_fini);
  pthread_mutex_unlock(& mutex_fini);
  if (DEBUG==1) printf("Dtachement du code thread\n");
  pthread_join(tache,NULL);
  /* on arrete l'envoi des logs */
  if (useSQL == 1) base_close();
  if (fichier_sortie != STDOUT_FILENO) close(fichier_sortie);
  printf("Temps de la commande: %f s\n",temps);
  exit(0);
}


int cree_douille_udp (broadcast)
  int broadcast;
{
  int sock;

  if ((sock = socket (AF_INET, SOCK_DGRAM, 0)) < 0) {
    erreur ("cration douille");
    return (-1);
  }
  setsockopt(sock,SOL_SOCKET,SO_BROADCAST, &broadcast,sizeof(broadcast));
  return (sock);
}

void ausecours()
{
  printf("logrecept [-h] [-a destination] [-p port_dest] [-w password]\n"); 
  printf("          [-i IP locale] [-l port_local]\n"); 
  printf("          [-y]\n"); 
  printf("          [-f fichier_de_sortie]\n"); 
  printf("          [-u fichier_de_log]\n"); 
  printf("Capture des logs d'un serveur HLDS Counter Strike.\n");
  printf("port par dfaut: 27015, lecture ventuelle des arguments dans ~/.rconhlds\n");
  printf("Si l'option -y est donne, une base MySQL est utilise, cf Doc\n");
  printf("port par dfaut: 27015, lecture ventuelle des arguments dans ~/.rconhlds\n");
  
  printf("Typiquement: logrecept -a 82.66.248.156 -w mot_de_passe -p 27016\n\n");
  printf("Franois Boisson Avril 2005\n");


  exit(2);
}


main(argc,argv)
int argc;
char **argv;
{
  /* programmation dgueulasse, ramassis de variables, tant pis */

  int i,j,k,l,n,nbp,e,fichier_local;
  int prt = PORT;
  struct sockaddr_in adresse_org;
  socklen_t lsock;
  struct hostent *   hostent  = NULL;
  struct servent *   servent  = NULL;
  struct protoent *  protoent = NULL;
  char *hote = NULL;
  char *local = NULL;
  char *sortie=NULL;
  FILE *fichier;
  int option;

  lignes=malloc(TAILLE_FILE*sizeof(char *));
  ligne_encours = 0;
  derniere_ligne = 0;
  lignes[0] = malloc(TAILLE_PAQUET);
  buffer=lignes[0];
  chdir(getpwuid(getuid())->pw_dir);
  if ((fichier=fopen(desc_serveur,"r")) != NULL)
    {
      if (fgets(buffer,1024,fichier) != NULL) 
	{
	  hote = malloc(256);
	  for (i=0;(i<256) && (buffer[i]!=0);i++) hote[i]=buffer[i];
          i--;
          while ((hote[i] == '\r') || (hote[i] == '\n')) i--;
          hote[++i]=0;
	}
      fscanf(fichier,"%d\n",&prt);
      if (fgets(buffer,1024,fichier) != NULL) 
	{
	  pass = malloc(128);
	  for (i=0;(i<127) && (buffer[i]!=0);i++) pass[i]=buffer[i];
          i--;
          while ((pass[i] == '\r') || (pass[i] == '\n')) i--;
          pass[++i]=0;
	}
      if (fgets(buffer,1024,fichier) != NULL) 
	{
	  IPlocale = malloc(128);
	  for (i=0;(i<127) && (buffer[i]!=0);i++) IPlocale[i]=buffer[i];
          i--;
          while ((IPlocale[i] == '\r') || (IPlocale[i] == '\n')) i--;
          IPlocale[++i]=0;
	}
      if (fscanf(fichier,"%d\n",&prtlc) == 0) prtlc = 0;
      fclose(fichier);
    }
  fichier_local=0;
  while ((option = getopt(argc,argv,"f:u:i:l:w:n:p:a:yh")) != -1) {
    switch(option) {
    case 'f':
      sortie = optarg;
      break;
    case 'a':
      hote = optarg;
      break;
    case 'w':
      pass = optarg;
      break;
    case 'i':
      IPlocale = optarg;
      break;
    case 'p':
      sscanf(optarg,"%d",&prt);
      break;
    case 'l':
      sscanf(optarg,"%d",&prtlc);
      break;
    case 'y':
      useSQL = 1;
      break;
    case 'u':
      fichier_local = 1;
      local = optarg;
      break;
    case 'h':
    case '?':
    default:
      ausecours(); 
      break;
    }
  }
  if (sortie != NULL) 
    if ((fichier_sortie = open(sortie,O_CREAT|O_RDWR|O_APPEND|O_SYNC,S_IRUSR|S_IWUSR|S_IROTH)) < 0)
      fichier_sortie  = STDOUT_FILENO;
    else printf("Sortie sur %s\n",sortie);
  else fichier_sortie = STDOUT_FILENO;
  if (useSQL ==1)
    {
      if ((fichier=fopen(FICHIER_MYSQL,"r")) != NULL)
	{
	  if (fgets(buffer,1024,fichier) != NULL) 
	    {
	      for (i=0;(i<32) && (buffer[i]!=0);i++) mysql_user[i]=buffer[i];
	      i--;
	      while ((mysql_user[i] == '\r') || (mysql_user[i] == '\n')) i--;
	      mysql_user[++i]=0;
	    }
	  if (fgets(buffer,1024,fichier) != NULL) 
	    {
	      for (i=0;(i<31) && (buffer[i]!=0);i++) mysql_password[i]=buffer[i];
	      i--;
	      while ((mysql_password[i] == '\r') || (mysql_password[i] == '\n')) i--;
	      mysql_password[++i]=0;
	    }
	  printf("U:>%s< P:>%s<\n",mysql_user,mysql_password);

	}
      else
	{
	  printf("Pas d'utilisateur MYSQL dfini, Mysql dsactiv\n");
	  useSQL=0;
	}
    }
  if(useSQL==1)
    {
      if (base_init() <0) erreur("MySQL inexistant?");
      if (base_connect(mysql_password,mysql_user) <0) 
	erreur("Utilisateur SQL non reconnu ou base inexistante"); 
    }
  if (fichier_local==1) /* utilisation d'un fichier local au lieu du serveur */
    {
      if ((fichier=fopen(local,"r")) != NULL)
    while (fgets(buffer,1024,fichier) != NULL)
      {
	if (DEBUG==1) printf("%s",buffer);
	traite(buffer);
      }
      fclose(fichier);
      exit(0);
    }

  printf("Serveur %s:%d\n",hote,prt);
  if ((hote == NULL) || (pass == NULL)) ausecours();
  douille = cree_douille_udp(1);

  signal(SIGINT,arret);

  if (hote != NULL)
    if ((hostent = gethostbyname (hote)) == NULL) {
      erreur ("gethostbyname");
      return (-1);
    }
  if (IPlocale == NULL) return(-1);
  
  if ((protoent = getprotobyname ("udp")) == NULL) {
    erreur ("getprotobyname");
    return (-1);
  }


  memset (& adresse, 0, sizeof (struct sockaddr_in));

  /* tablissement du port de sortie */ 

  adresse . sin_family = AF_INET;
  if (prtlc != 0) adresse.sin_port = htons(prtlc);
  else adresse . sin_port = htons (0);

  adresse . sin_addr . s_addr = htonl (INADDR_ANY);

  if (bind (douille, (struct sockaddr *) & adresse,
            sizeof (struct sockaddr_in)) < 0) {
    close (douille);
    erreur ("localisation douille");
    return (-1);
  }


  adresse . sin_family = AF_INET;
  if (prt != 0) adresse.sin_port = htons(prt);
  else adresse . sin_port = htons (0);
  if (hostent != NULL)
    adresse . sin_addr . s_addr =
      ((struct in_addr *) (hostent -> h_addr)) -> s_addr;
  else erreur("pas de destinataire");
  i =  sizeof (struct sockaddr_in);


  /* lancement du thread */
  pthread_create(&tache,NULL,tache_de_fond,NULL);
  /* initialisation compteur temps */
  temps=times(NULL);

  /* envoi rcon */
  buffer[0]=buffer[1]=255;
  buffer[2]=buffer[3]=255;
  k=4;
  for (j=0;debut[j]!=0;j++) buffer[k++]=debut[j];
  buffer[k]=0;


  sendto(douille,buffer,k,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));

  /* on rcupre le numro du port et l'IP locale */
  lsock=sizeof(struct sockaddr);
  getsockname(douille,(struct sockaddr *) &adresse_org,&lsock);
  prtlc = intostring(ntohs(adresse_org.sin_port),10);
  l=recvfrom(douille,buffer,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,
	    &i);
  printf("Machine locale: %s:%s\n",IPlocale,prtlc);

  for (k=19;(k<l) && (buffer[k] !=10);k++) challenge[k-19]=buffer[k];

  challenge[k-19]=0;
  printf("Challenge: %s\n",challenge);

  /* preparation commande logaddress IP portlocal */
  buffer[0]=buffer[1]=255;
  buffer[2]=buffer[3]=255;
  k=4;
  buffer[k++]='r';
  buffer[k++]='c';
  buffer[k++]='o';
  buffer[k++]='n';
  buffer[k++]=' ';
  for (j=0;challenge[j]!=0;j++) buffer[k++]=challenge[j];
  buffer[k++]=' ';
  buffer[k++]='"';
  for (j=0;pass[j]!=0;j++) buffer[k++]=pass[j];
  buffer[k++]='"';
  buffer[k++]=' ';
  for (j=0;cmdlog[j]!=0;j++) buffer[k++]=cmdlog[j];
  buffer[k++]=' ';
  for (j=0;IPlocale[j]!=0;j++) buffer[k++]=IPlocale[j];
  buffer[k++]=' ';
  for (j=0;prtlc[j]!=0;j++) buffer[k++]=prtlc[j];


  sendto(douille,buffer,k,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));
  
  /* reception commande */
  while (1==1)
    {
      l=recvfrom(douille,buffer,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,&i);
      if (l >= 4) 
	{
	  if (buffer[0]=255) 
	    {
	      /* un seul paquet */
	      buffer[l]=0;
	      rajoute();
	      /* au lieu de traite(buffer+8)*/
	      /*	      	      printf("%s",buffer+8);*/
	    }
	  else
	    /*plusieurs paquets, faudra voir mais a n'arrive pas  */
	    {
	      nbp=(buffer[8]&15);
	      i = buffer[8]/16;
	      for (j=0;j<l-9;j++) buffer_total[i*(TAILLE_PAQUET-8)+j]=buffer[j];
	      n=l-9;
	      for (;nbp>0;nbp--)
		{
		  l=recvfrom(douille,buffer,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,
			     &i);
		  i = buffer[8]/16;
		  n+=(l-9);
		  for (j=0;j<l-9;j++) buffer_total[i*(TAILLE_PAQUET-8)+j]=buffer[j];
		}
	      buffer_total[l]=0;
	      printf("%s",buffer_total);
	      
	    }
	}
    }

  exit(0);
}


